import 'package:flutter/material.dart';
import 'package:flutter_markdown/flutter_markdown.dart';
import 'package:gymlink_module_web/components/app_bar.dart';
import 'package:gymlink_module_web/components/heading.dart';
import 'package:gymlink_module_web/components/order_confirm_item_card.dart';
import 'package:gymlink_module_web/interfaces/items.dart';
import 'package:gymlink_module_web/pages/order_history.dart';
import 'package:gymlink_module_web/providers/cart.dart';
import 'package:gymlink_module_web/tools/items.dart';
import 'package:gymlink_module_web/tools/prefs.dart';
import 'package:gymlink_module_web/tools/routes.dart';
import 'package:provider/provider.dart';
import 'package:url_launcher/url_launcher.dart';

List<Map<String, dynamic>> cart = [
  {
    "name": "Протеин",
    "image": "product.png",
    "price": "120",
    "details": "Test details",
    "id": "34fa3126-bfaf-5dec-8f4a-b246c097ef73"
  },
  {
    "name": "Протеин",
    "image": "product.png",
    "price": "150",
    "details": "Test details",
    "id": "34a26e82-7656-5e98-a44a-c2d01d0b1ad1123"
  },
  {
    "name": "Протеин",
    "image": "product.png",
    "price": "250",
    "details": "Test details",
    "id": "4fb204b7-3f9e-52a2-bed1-415c00a31a37123"
  },
  {
    "name": "Протеин",
    "image": "product.png",
    "price": "300",
    "details": "Test details",
    "id": "09b2f5bb-683e-5c39-ae89-b8e152fa8bcf123"
  },
  {
    "name": "Протеин",
    "image": "product.png",
    "price": "100",
    "details": "Test details",
    "id": "cd1b6817-db94-5394-be1d-af88af79749f123"
  }
];

class OrderConfirmationPage extends StatefulWidget {
  const OrderConfirmationPage({super.key});

  @override
  State<OrderConfirmationPage> createState() => _OrderConfirmationPageState();
}

class _OrderConfirmationPageState extends State<OrderConfirmationPage> {
  List<GymItem> cartItems = [];
  double totalPrice = 0;
  List<GymItem> gymCart = [];
  bool _isLoading = true;

  @override
  void initState() {
    super.initState();
    Future.microtask(() => getCart().then((value) async {
          final itemIds =
              value.map((element) => element['id'] as String).toList();
          final items = await getItemsByIds(context, itemIds);
          setState(() {
            gymCart = items;
            cartItems = value.map((element) {
              final item = gymCart.firstWhere((e) => e.id == element['id']);
              item.localCount = element['count'] as int;
              return item;
            }).toList();
            totalPrice = cartItems.fold(
                0, (sum, item) => sum + item.price * item.localCount);
            _isLoading = false;
          });
        }));
  }

  Future<void> _goToPage() async {
    final Uri url = Uri.parse('https://google.com');
    if (!await launchUrl(url, webOnlyWindowName: '_blank')) {
      throw 'Could not launch $url';
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: const GymLinkAppBar(),
      resizeToAvoidBottomInset: false,
      body: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          const GymLinkHeader(title: 'Оформление заказа'),
          const MarkdownBody(data: '## Состав заказа:'),
          Expanded(
            child: _isLoading
                ? const Center(child: CircularProgressIndicator())
                : ConstrainedBox(
                    constraints: const BoxConstraints(maxHeight: 350),
                    child: ListView.builder(
                      itemCount: cartItems.length,
                      itemBuilder: (context, index) {
                        final item = cartItems[index];
                        return OrderConfirmItemCard(
                          name: item.title,
                          image: Image(
                              image: NetworkImage(item.images[0].url),
                              width: 50,
                              height: 50),
                          price: item.price,
                          count: item.localCount,
                        );
                      },
                    ),
                  ),
          ),
          const SizedBox(
            height: 10,
          ),
          Expanded(
            child: Column(
              children: [
                MarkdownBody(data: '## Итого: $totalPrice'),
                Expanded(
                  child: TextField(
                    decoration: InputDecoration(
                      hintText: 'Адрес доставки',
                      border: OutlineInputBorder(
                        borderRadius: BorderRadius.circular(10),
                      ),
                    ),
                  ),
                ),
                Expanded(
                  child: TextField(
                    decoration: InputDecoration(
                      hintText: 'Электронная почта',
                      border: OutlineInputBorder(
                        borderRadius: BorderRadius.circular(10),
                      ),
                    ),
                    keyboardType: TextInputType.emailAddress,
                  ),
                ),
                Expanded(
                  child: TextField(
                    decoration: InputDecoration(
                      hintText: 'Получатель',
                      border: OutlineInputBorder(
                        borderRadius: BorderRadius.circular(10),
                      ),
                    ),
                  ),
                ),
                ElevatedButton(
                  onPressed: () async {
                    _goToPage();
                    await clearCart();
                    Provider.of<CartProvider>(context, listen: false)
                        .updateCartLength();
                    Navigator.of(context).pushAndRemoveUntil(
                        CustomPageRoute(
                            builder: (context) => const HistoryPage()),
                        (route) => route.isFirst);
                  },
                  style: ElevatedButton.styleFrom(
                    backgroundColor: Theme.of(context).primaryColor,
                    shape: const RoundedRectangleBorder(
                      borderRadius: BorderRadius.all(Radius.circular(50)),
                    ),
                    foregroundColor: Colors.white,
                  ),
                  child: const Text('Оформить заказ'),
                ),
                const SizedBox(height: 20),
              ],
            ),
          ),
        ],
      ),
    );
  }
}
